turf/icon = 'grass.dmi'

world
	maxx = 50
	maxy = 50
client/view = "50x50"

var/client/CLIENT

client/New()
	..()
	CLIENT = src
	src << "Use one of the verbs to continue. Please don't use multiple verbs at once"
	src << "Oh yeah, and don't use this demo for any sort of learning. I was bored, and programmed as so"

mob/proc/Building_Gen()
	var/JEF_COL/C = new(8,"H4x")
	for(var/X in 2 to 22)
		for(var/Y in 1 to 45)
			C.contents += new /obj/building(locate(X,Y,1))
	for(var/X in 25 to 45)
		for(var/Y in 1 to 45)
			C.contents += new /obj/building(locate(X,Y,1))
	C.UDT() //update the tags of all it's contents. Might not need to be done in some cases, but they would be rare!

proc/Watch_OBJ(obj/O)
	CLIENT.perspective = EYE_PERSPECTIVE
	CLIENT.eye = O
	CLIENT.view = "10x10"

mob/verb
	Close_view() client.view = "10x10"
	Zoomed_out_view() client.view = "50x50"

mob/verb/Terrorists()
	Building_Gen()
	world << "You are watching the news. The day is September 11, 2001"
	world << "Please note that all \"lag\" that is created is just because of your view size (50X50 in a few moments)"
	Watch_OBJ(new/obj/plane())

mob/verb/Government_Conspiracy()
	Building_Gen()
	world << "You are a top secret government spy guy guarding the area around the WTC"
	sleep(3)
	world << "We don't wan't your secret blown!"
	world << "Please note that all \"lag\" that is created is just because of your view size (50X50 in a few moments)"
	Watch_OBJ(new/obj/Gov/init())

obj/plane
	icon = 'plane.dmi'
	density = 1
	New()
		loc = locate(world.maxx,35,1)
		walk(src,WEST,5)
	Bump(obj/building/O)
		if(istype(O,/obj/building))
			CLIENT.eye = locate(25,25,1)
			CLIENT.view = "50x50"
			var/JEF_COL/C = JEF_col.Get_Det(O.tag)
			if(!C) CRASH("Get_Det() returned null")
			loc = null
			C.Demolish()
			del(src)

obj/Gov
	layer = 4
	init
		icon = 'gov.dmi'
		New()
			loc = locate(20,1,1)
			for(var/X in 9 to 19)
				new /obj/Gov/r/Line(locate(X,1,1))
			new/obj/Gov/r/dyna(locate(9,1,1))
			new/obj/Gov/r/det(locate(19,1,1))
			world << "Government guy: Haha, time to make some asplosions!"
			new/obj/Gov/r/Spark()

	r
		Line
			icon = 'line.dmi'
		dyna
			density = 1
			icon = 'dyna.dmi'
		det
			icon = 'det.dmi'
		Spark
			density = 0
			icon = 'spark.dmi'
			New()
				loc = locate(20,1,1)
				Watch_OBJ(src)
				walk(src,WEST,3)
				sleep(30)
				Explode()
			proc/Explode()
				CLIENT.eye = locate(25,25,1) //copied and pasted. I'm too lazy to make another proc (gov was a last min thing)
				CLIENT.view = "50x50"
				world << "BOOM!"
				var/obj/building/O = locate()
				var/JEF_COL/C = JEF_col.Get_Det(O.tag)
				if(!C) CRASH("Get_Det() returned null")
				loc = null
				for(var/obj/Gov/Z in world)
					if(Z == src) continue
					del(Z)
				C.Demolish()
				del(src)

obj/Line

JEF_COL
	On_Tier(l[])
		for(var/atom/movable/A in l)
			new /obj/smoke(A.loc)
		for(var/Z in 1 to 3)
			var/obj/building/X = pick(contents)
			new /obj/Person (X.loc)
	On_Collapse()
		world << "Thus, the WTC was demolished and many died"
		sleep(10)
		world << "You just destroyed an 1890 tile building, created 1000+ smoke effects, \
		150 people, and destroyed them all with about 1% CPU"

obj/smoke
	icon = 'smoke.dmi'
	New()
		..()
		world << "Crash!"
		walk_rand(src,5)
		spawn(100)
			del(src)

obj/Person
	icon = 'person.dmi'
	New()
		..()
		var/Z = y
		world << "Person: Agh!"
		walk(src,SOUTH,1)
		spawn(Z) del(src)

obj/building
	density = 1
	icon = 'building.dmi'