var/JEF_col_master/JEF_col = new

JEF_col_master
	var/PASS_TAG = "" //to make all building tags original. Made easily editable for your convenience

	proc/Get_Det(T) //where T is the tag of an object with a JEF_COL collapsing datum thing
		var/End = findText(T,PASS_TAG)
		return locate(copytext(T,1,End))

JEF_COL
	var/list/contents = new
	var/speed = 1

	New(sped,tg)
		speed = sped
		tag = tg
		..()

	proc

		UDT()
			var/i = 0
			for(var/atom/movable/X in contents)
				X.tag = "[tag][JEF_col.PASS_TAG][i]" //give it a unique tag
				i++
				X.animate_movement = NO_STEPS //make the collapse look better

		Demolish()
			var
				dbases
				list/bases = get_bases()

			Pre_Collapse(bases)

			while(locate(/atom/movable) in contents)
				for(var/atom/movable/A in contents)
					A.pixel_y -= speed
					if(A.pixel_y <= -32)
						A.pixel_y %= 32
						A.loc = locate(A.x,A.y-1,A.z)
						dbases = 1
				if(dbases)
					dbases = null
					On_Tier(bases)
					for(var/atom/movable/A in bases) del(A)
					bases = get_bases()
				sleep(1)
			On_Collapse(bases)
			for(var/atom/movable/X in bases) del(X)
			del(src)

		Sort()
			var/list/base = new
			var/i = world.maxy+1
			for(var/atom/movable/A in contents)
				if(A.y == i)
					base += A
				if(A.y < i)
					i = A.y
					base = list(A)
			return base

		get_bases()
			var/list/bases = Sort()
			contents -= bases
			return bases

		get_tier(var/Z as num)
			var/atom/movable/X = locate() in Sort()
			. = list()
			if(!X) CRASH("Nothing in contents, so nothing in get_bases(), so there's an error. Nub")
			if(!(isnum(Z))) CRASH("Z isn't a number!")
			for(var/atom/movable/Y in contents)
				if((Y.y - X.y) == Z)
					. += Y

		get_tiers_greater_equal(var/Z as num)
			var/atom/movable/X = locate() in Sort()
			. = list()
			if(!X) CRASH("Nothing in contents, so nothing in get_bases(), so there's an error. Nub")
			if(!(isnum(Z))) CRASH("Z isn't a number!")
			for(var/atom/movable/Y in contents)
				if((Y.y - X.y) >= Z)
					. += Y

		get_tiers_less_equal(var/Z as num)
			var/atom/movable/X = locate() in Sort()
			. = list()
			if(!X) CRASH("Nothing in contents, so nothing in get_bases(), so there's an error. Nub")
			if(!(isnum(Z))) CRASH("Z isn't a number!")
			for(var/atom/movable/Y in contents)
				if((Y.y - X.y) <= Z)
					. += Y

		get_height()
			var/list/covered = new

			var/atom/movable/TEST = locate() in Sort()
			if(!TEST) CRASH("Nothing in contents, so nothing in get_bases(), so there's an error. Nub")

			for(var/atom/movable/X in contents)
				var/Z = X.y-TEST.y
				if(Z in covered) continue
				.++
				covered += Z

		get_tile_height(atom/movable/A)
			var/atom/movable/TEST = locate() in Sort()
			if(!TEST) CRASH("Nothing in contents, so nothing in get_bases(), so there's an error. Nub")
			return A.y-TEST.y

		On_Tier(list/bases)

		On_Collapse(list/bases)

		Pre_Collapse(list/bases)